<?php

class Hub2b_Customapi_Model_Hub2b_Api extends Mage_Api_Model_Resource_Abstract
{
   public $m_LOG = '';

   public function appendLog($message)
   {
	  if (is_null($message) or strlen($message) <= 0)
		 return;

	  $this->m_LOG .= ($message . "\r\n");
	  Mage::log($message, null, 'hub2b.log');
   }
   
   public function hub2b($msg) 
   {
	  return "Hub2b extension API in Magento. Here is Your Message ". $msg ;
   }
   
	public function getExistingOrder($orderNumber)
	{
		$this->appendLog('Checking order ' . $orderNumber);
		
		$prefix = Mage::getConfig()->getTablePrefix();
		
		$resource = Mage::getSingleton('core/resource');
		$readConnection = $resource->getConnection('core_read');

		$query = "select increment_id".			
		"           from ".$prefix."sales_flat_order".					
		"          where source_order_number = '".$orderNumber . "'";

		$result = $readConnection->fetchAll($query);				
		
		$pedido = "";
		
		foreach($result as $key => $value)
		{
			$pedido = $value['increment_id'];
			
			if($pedido != "")
			{
				$this->appendLog("Order " . $orderNumber . " already registered!");		
				return $pedido;
			}
		}					
		
		return "";
	}	
   
   
   public function version()
   {
		//MAJOR version when you make incompatible API changes
		//MINOR version when you add functionality in a backwards-compatible manner
		//PATCH version when you make backwards-compatible bug fixes
		return "1.16.1.5";
   }

   public function ping() 
   {
	   return "pong";
   }
   
   public function isAPI()
   {
	   return Mage::getSingleton('api/session')->getSessionId() != "";
   }
   
   public function array_to_xml( $data, &$xml_data ) {
	  foreach( $data as $key => $value ) {
		 if( is_array($value) ) {
			if( is_numeric($key) ){
			   $key = 'item'; //dealing with <0/>..<n/> issues
			}
			$subnode = $xml_data->addChild($key);
			$this->array_to_xml($value, $subnode);
		 } else {
			$xml_data->addChild("$key",htmlspecialchars("$value"));
		 }
	   }
   }
	  
	 function getExceptionTraceAsString($exception) {
    $rtn = "";
    $count = 0;
    foreach ($exception->getTrace() as $frame) {
        $args = "";
        if (isset($frame['args'])) {
            $args = array();
            foreach ($frame['args'] as $arg) {
                if (is_string($arg)) {
                    $args[] = "'" . $arg . "'";
                } elseif (is_array($arg)) {
                    $args[] = "Array";
                } elseif (is_null($arg)) {
                    $args[] = 'NULL';
                } elseif (is_bool($arg)) {
                    $args[] = ($arg) ? "true" : "false";
                } elseif (is_object($arg)) {
                    $args[] = get_class($arg);
                } elseif (is_resource($arg)) {
                    $args[] = get_resource_type($arg);
                } else {
                    $args[] = $arg;
                }   
            }   
            $args = join(", ", $args);
        }
        $rtn .= sprintf( "#%s %s(%s): %s(%s)\n",
	$count,
	isset($frame['file']) ? $frame['file'] : 'unknown file',
	isset($frame['line']) ? $frame['line'] : 'unknown line',
	(isset($frame['class']))  ? $frame['class'].$frame['type'].$frame['function'] : $frame['function'],
	$args );
        $count++;
    }
    return $rtn;
} 
	  
	function MakePrettyException(Exception $e)
	{
		$result = '';

		try
		{
			$trace = $e->getTrace();

			if ($e != null && $e->getMessage() != null)
			{
				$result = 'Exception: "';
				$result .= (string)$e->getMessage();

				if ($trace != null && $trace[0] != null && $trace[0]['line'] != null)
					$result .= ' Line: ' . (string)$trace[0]['line'];
			}

			Mage::log($this->getExceptionTraceAsString($e), null, 'hub2b.log');

			return $result;
		}
		catch(Exception $ee)
		{  
			Mage::logException($ee);
			return (string)$ee->getMessage();
		}
	}
	    
	public function eav_attribute($xmlConfigBase="")
	{
		if (!$this->isAPI())
		{
			$this->appendLog('eav_attribute only available through API');
			return "<error>not API</error>";
		}
		try
		{
			if (strlen($xmlConfigBase) > 0)
			{
				$XMLobj = simplexml_load_string($xmlConfigBase);

				$tbl = $XMLobj->xpath("//*[name() = 'tabela']");
				$tblName = (string)$tbl[0][0];	
			}				
			
			$prefix = Mage::getConfig()->getTablePrefix();
			$resource = Mage::getSingleton('core/resource');
			$readConnection = $resource->getConnection('core_read');

			if ($tblName == "")
				$query = "select * from ".$prefix."eav_attribute order by is_user_defined, attribute_code";
			else
				$query = "select * from ".$prefix.$tblName;

			$result = $readConnection->fetchAll($query);

			$xml_data = new SimpleXMLElement('<?xml version="1.0"?><data></data>');

			// function call to convert array to xml
			$this->array_to_xml($result,$xml_data);

			//saving generated xml file; 
			return $xml_data->asXML();
		}
		catch (Exception $e)
		{
			Mage::logException($e);
			return "<error>".$this->MakePrettyException($e)."</error>";
		}
	}

	public function categoryList()
	{
		if (!$this->isAPI())
		{
			$this->appendLog('categoryList only available through API');
			return "<error>not API</error>";
		}

		try
		{
			$prefix = Mage::getConfig()->getTablePrefix();
			$resource = Mage::getSingleton('core/resource');
			$readConnection = $resource->getConnection('core_read');

			$query = "select distinct ".
						"main_table.entity_id AS id, ".
						"at_name.value AS name, ".
						"main_table.level, ".
						"main_table.parent_id ".
					"from ".$prefix."catalog_category_entity main_table ".
					"inner join ".$prefix."eav_entity_type eav_type on main_table.entity_type_id = eav_type.entity_type_id and eav_type.entity_type_code = 'catalog_category' ".
					"inner join ".$prefix."eav_attribute eav on eav.entity_type_id = eav_type.entity_type_id and eav.attribute_code = 'name' ".
					"inner join ".$prefix."catalog_category_entity_varchar at_name on at_name.entity_id = main_table.entity_id and at_name.attribute_id = eav.attribute_id; ";

			$result = $readConnection->fetchAll($query);

			$xml_data = new SimpleXMLElement('<?xml version="1.0"?><data></data>');

			// function call to convert array to xml
			$this->array_to_xml($result,$xml_data);

			//saving generated xml file; 
			return $xml_data->asXML();
		}
		catch (Exception $e)
		{
			Mage::logException($e);
			return "<error>".$this->MakePrettyException($e)."</error>";
		}
	}

	public function productOperationList($xmlConfigBase="") 
	{
		if (!$this->isAPI())
		{
			$this->appendLog('productOperationList only available through API');
			return "<error>not API</error>";
		}

		try
		{
			$websiteIdStr = "1";
			$storeViewStr = "0";
			$pagination = "";

			if (strlen($xmlConfigBase) > 0)
			{
				$XMLobj = simplexml_load_string($xmlConfigBase);

				$websiteId = $XMLobj->xpath("//*[name() = 'websiteId']");
				$websiteIdStr = (string)$websiteId[0][0];

				$storeView = $XMLobj->xpath("//*[name() = 'storeView']");
				$storeViewStr = (string)$storeView[0][0];

				$limit = $XMLobj->xpath("//*[name() = 'limit']");
				$limitStr = (string)$limit[0][0];

				$offset = $XMLobj->xpath("//*[name() = 'offset']");
				$offsetStr = (string)$offset[0][0];

				$hourssubtract = $XMLobj->xpath("//*[name() = 'hoursSubtract']");
				$hourssubtractStr = (string)$hourssubtract[0][0];

				if (strlen($hourssubtractStr) > 0)
				{
					$hourssubtractStr = " and pb.updated_at >= SUBDATE(now(), INTERVAL " . $hourssubtractStr . " hour) ";
				}
				
				if (strlen($limitStr) > 0 && strlen($offsetStr) > 0)
				{
					$pagination = " limit " . $limitStr . " offset " . $offsetStr;
				}
			}

			$prefix = Mage::getConfig()->getTablePrefix();
			$resource = Mage::getSingleton('core/resource');
			$readConnection = $resource->getConnection('core_read');

			/* STOCK RULES:
			The stock will return 500 if:
			 - The product is enabled (status 1) and both flags manage_stock and use_config_manage_stock are zero; That is right indeed.

			else if the stock will return 0 (zero):
			 - The product is disabled (status = 2);
			 - The product availability is_in_stock = 0 (out of stock);
			 
			If any of the previous conditions were not met, then returns the product qty. */

			$query = "select p.sku, p.entity_id as sourceId,". 
			"						   (select pr.value".
			"							  from ".$prefix."catalog_product_entity_varchar pr, ".
			"								   ".$prefix."eav_attribute attr".
			"							 where pr.attribute_id = attr.attribute_id".
			"							   and pr.entity_id = p.entity_id".
			"                       and pr.store_id = '".$storeViewStr."'".
			"							   and attr.attribute_code = 'name') as name,".
			"						   case".
			"								when coalesce(s.value, 0) <> 2 and manage_stock = 0 and use_config_manage_stock = 0 then ".
			"									500".
			"								when coalesce(s.value, 0) <> 2 and is_in_stock = 1 then ".
			"									replace(round(qty, 0), ',', '.') ".
			"								else ".
			"									0".
			"						   end as stock,".
			"						   (select replace(round(pr.value, 2), ',', '.')".
			"							  from ".$prefix."catalog_product_entity_decimal pr, ".$prefix."eav_attribute attr".
			"							 where pr.attribute_id = attr.attribute_id".
			"							   and attr.attribute_code = 'price'".
			"							   and pr.entity_id = p.entity_id".
			"                       and pr.store_id = '".$storeViewStr."') as defaultPrice,".
			"						   (select replace(round(pr.value, 2), ',', '.')".
			"							  from ".$prefix."catalog_product_entity_decimal pr, ".$prefix."eav_attribute attr".
			"							 where pr.attribute_id = attr.attribute_id".
			"							   and attr.attribute_code = 'minimal_price'".
			"							   and pr.entity_id = p.entity_id".
			"                       and pr.store_id = '".$storeViewStr."') as minimalPrice,".			
			"						case when current_date >= coalesce(fromdate, current_date) and current_date <= coalesce(todate, current_date) then ".
			"						   (select replace(round(pr.value, 2), ',', '.')".
			"							 from ".$prefix."catalog_product_entity_decimal pr, ".$prefix."eav_attribute attr".
			"							where pr.attribute_id = attr.attribute_id".
			"							  and attr.attribute_code = 'special_price'".
			"							  and pr.entity_id = p.entity_id".
			"                      		  and pr.store_id = '".$storeViewStr."') ".
			"					   	else null ".
			"					    end as sellPrice". 
			"               FROM (select * from ".$prefix."catalog_product_entity pb".
			"                   inner join ".$prefix."catalog_product_website ps on ps.product_id = pb.entity_id ".
			$hourssubtractStr.
			"                      and ps.website_id = '".$websiteIdStr."'" . $pagination . ") as p ".
			"					left outer join ".$prefix."cataloginventory_stock_item stck on stck.product_id = p.entity_id ".
			"                   left outer join (select pr.value, pr.entity_id from ".$prefix."catalog_product_entity_int pr, ".$prefix."eav_attribute attr where pr.attribute_id = attr.attribute_id and pr.store_id = '".$storeViewStr."' and attr.attribute_code = 'status') as s on s.entity_id = p.entity_id ".
			"                   left outer join (select pr.value as fromdate, pr.entity_id from ".$prefix."catalog_product_entity_datetime pr, ".$prefix."eav_attribute attr where pr.attribute_id = attr.attribute_id and pr.store_id = '".$storeViewStr."' and attr.attribute_code = 'special_from_date') as sfd on sfd.entity_id = p.entity_id ".
			"                   left outer join (select pr.value as todate, pr.entity_id from ".$prefix."catalog_product_entity_datetime pr, ".$prefix."eav_attribute attr where pr.attribute_id = attr.attribute_id and pr.store_id = '".$storeViewStr."' and attr.attribute_code = 'special_to_date') as std on std.entity_id = p.entity_id ";

			$result = $readConnection->fetchAll($query);

			$xml_data = new SimpleXMLElement('<?xml version="1.0"?><data></data>');

			$this->array_to_xml($result,$xml_data);

			return $xml_data->asXML();
		}
		catch (Exception $e)
		{
			Mage::logException($e);
			return "<error>".$this->MakePrettyException($e)."</error>";
		}
	}
   
	public function productLoadList($xmlConfigBase) 
	{
		if (!$this->isAPI())
		{
			$this->appendLog('productLoadList only available through API');
			return "<error>not API</error>";
		}

		try
		{
			$orderXMLobj = simplexml_load_string($xmlConfigBase);

			$limit = $orderXMLobj->xpath("//*[name() = 'limit']");
			$limitStr = (string)$limit[0][0];

			$offset = $orderXMLobj->xpath("//*[name() = 'offset']");
			$offsetStr = (string)$offset[0][0];

			$pagination = "";
			if (strlen($limitStr) > 0 && strlen($offsetStr) > 0)
			{
				$pagination = " limit " . $limitStr . " offset " . $offsetStr;
			}

			$websiteId = $orderXMLobj->xpath("//*[name() = 'websiteId']");
			$websiteIdStr = (string)$websiteId[0][0];

			$storeView = $orderXMLobj->xpath("//*[name() = 'storeView']");
			$storeViewStr = (string)$storeView[0][0];

			$fieldsbyAttrCode = $orderXMLobj->xpath("//*[name() = 'fieldsbyAttrCode']");
			$fieldsbyAttrCodeStr = (string)$fieldsbyAttrCode[0][0];

			$fieldsbyAttrCodeToSkip = $orderXMLobj->xpath("//*[name() = 'fieldsbyAttrCodeToSkip']");
			$fieldsbyAttrCodeToSkipStr = (string)$fieldsbyAttrCodeToSkip[0][0];

			$URLMedia = Mage::getBaseUrl(Mage_Core_Model_Store::URL_TYPE_MEDIA) . 'catalog/product/';

			$prefix = Mage::getConfig()->getTablePrefix();
			$resource = Mage::getSingleton('core/resource');
			$readConnection = $resource->getConnection('core_read');

			$query = 
			"SELECT * FROM ( ".
				"SELECT ".
				"ce.entity_id, ".
				"ce.sku, ".
				"(SELECT parent.sku ".
				"FROM ".$prefix."catalog_product_relation r ".
				"INNER JOIN ".$prefix."catalog_product_entity parent ON parent.entity_id = r.parent_id ".
				"WHERE r.child_id = ce.entity_id LIMIT 1) AS parentsku, ".
				"CASE ".
				"   WHEN is_in_stock = 1 then ".
				"      replace(round(qty, 0), ',', '.') ".
				"   ELSE ".
				"      0 ".
				"END as stock, ".
				"ea.is_user_defined, ".
				"(select cc.entity_id from ".$prefix."catalog_category_entity cc ".
				"  join ".$prefix."catalog_category_product cp on cc.entity_id = cp.category_id ".
				"  where cp.product_id = ce.entity_id order by cc.entity_id desc limit 1)  as category, ".
				"ea.attribute_code, ".
				"ea.frontend_label AS attribute, ".
				"CASE ea.backend_type ".
				"WHEN 'varchar' THEN ".
				"( ".
					"CASE ea.attribute_code ".
					"WHEN 'url_path' THEN concat ('".Mage::getBaseUrl()."', ce_varchar.value) ".
					"WHEN 'media_gallery' THEN concat ('".$URLMedia."', ce_gallery.value) ".
					"WHEN 'image' THEN concat ('".$URLMedia."', ce_varchar.value) ".
					"ELSE ce_varchar.value ".
					"END ".
				") ".
				"WHEN 'int' THEN ".
				"( ".
					"CASE ea.frontend_input ".
					"WHEN 'select' THEN (SELECT o.value  ".
									"FROM ".$prefix."eav_attribute_option_value o  ".
									"WHERE o.option_id = ce_int.value LIMIT 1) ".
					"ELSE ce_int.value ".
					"END ".
				") ".
				"WHEN 'text' THEN ".
				"( ".
					"CASE ea.frontend_input ".
					"WHEN 'select' THEN (SELECT o.value  ".
									"FROM ".$prefix."eav_attribute_option_value o  ".
									"WHERE o.option_id = ce_text.value LIMIT 1) ".
					"WHEN 'multiselect' THEN (SELECT group_concat(o.value)  ".
									"FROM ".$prefix."eav_attribute_option_value o  ".
									"WHERE o.option_id = ce_text.value) ".									
					"ELSE ce_text.value ".
					"END ".
				") ".
				"WHEN 'decimal' THEN REPLACE(round(ce_decimal.value, 2), ',', '.') ".
				"WHEN 'datetime' THEN ce_datetime.value ".
				"ELSE ea.backend_type ".
				"END AS value ".
				"FROM (select * from ".$prefix."catalog_product_entity p  ".
					"inner join ".$prefix."catalog_product_website ps on ps.product_id = p.entity_id ".
					"and ps.website_id = '".$websiteIdStr."'
					" . $pagination . ") as ce ".
				"INNER JOIN ".$prefix."eav_attribute AS ea ".
				"ON ce.entity_type_id = ea.entity_type_id ".
				"AND ".
				"((ea.attribute_code IN (".$fieldsbyAttrCodeStr.")) ".
				"OR ".
				"(ea.is_user_defined = 1 AND ea.attribute_code NOT IN (".$fieldsbyAttrCodeToSkipStr."))) ".
				"LEFT JOIN ".$prefix."catalog_product_entity_varchar AS ce_varchar ".
				"ON ce.entity_id = ce_varchar.entity_id ".
				"AND ea.attribute_id = ce_varchar.attribute_id ".
				"AND ce_varchar.store_id = '".$storeViewStr."' ".
				"LEFT JOIN ".$prefix."catalog_product_entity_int AS ce_int ".
				"ON ce.entity_id = ce_int.entity_id ".
				"AND ea.attribute_id = ce_int.attribute_id ".
				"AND ce_int.value IS NOT NULL ".
				"AND ce_int.store_id = '".$storeViewStr."' ".
				"LEFT JOIN ".$prefix."catalog_product_entity_text AS ce_text ".
				"ON ce.entity_id = ce_text.entity_id ".
				"AND ea.attribute_id = ce_text.attribute_id ".
				"AND ce_text.store_id = '".$storeViewStr."' ".
				"LEFT JOIN ".$prefix."catalog_product_entity_decimal AS ce_decimal ".
				"ON ce.entity_id = ce_decimal.entity_id ".
				"AND ea.attribute_id = ce_decimal.attribute_id ".
				"AND ce_decimal.store_id = '".$storeViewStr."' ".
				"LEFT JOIN ".$prefix."catalog_product_entity_datetime AS ce_datetime ".
				"ON ce.entity_id = ce_datetime.entity_id ".
				"AND ea.attribute_id = ce_datetime.attribute_id ".
				"AND ce_datetime.store_id = '".$storeViewStr."' ".
				"LEFT JOIN (select g.entity_id, g.attribute_id, g.value from ".$prefix."catalog_product_entity_media_gallery g, ".
							$prefix."catalog_product_entity_media_gallery_value v where g.value_id = v.value_id ".
							"order by v.position) AS ce_gallery ".
				"ON ce.entity_id = ce_gallery.entity_id ".
				"AND ea.attribute_id = ce_gallery.attribute_id ".
				"LEFT JOIN ".$prefix."cataloginventory_stock_item stck on stck.product_id = ce.entity_id ".
			") AS products ".
			"WHERE value IS NOT NULL ".
			"ORDER BY entity_id, is_user_defined; ";

			$result = $readConnection->fetchAll($query);
			$xml_data = new SimpleXMLElement('<?xml version="1.0"?><data></data>');

			// function call to convert array to xml
			$this->array_to_xml($result,$xml_data);

			//saving generated xml file; 
			return $xml_data->asXML();
		}
		catch (Exception $e)
		{
			Mage::logException($e);
			return "<error>".$this->MakePrettyException($e)."</error>";
		}
	}

	public function productIdSKUList()
	{
		if (!$this->isAPI())
		{
			$this->appendLog('productIdSKUList only available through API');
			return "<error>not API</error>";
		}

		try
		{
			$prefix = Mage::getConfig()->getTablePrefix();
			$resource = Mage::getSingleton('core/resource');
			$readConnection = $resource->getConnection('core_read');

			$query = "select p.sku as id,".
			"           p.entity_id as productId,".
			"           (select pr.value".
			"              from ".$prefix."catalog_product_entity_varchar pr, ".
			"                   ".$prefix."eav_attribute attr".
			"                where pr.attribute_id = attr.attribute_id".
			"                  and pr.entity_id = p.entity_id".
			"                  and attr.attribute_code = 'name') as name".
			"           from ".$prefix."catalog_product_entity p";

			$result = $readConnection->fetchAll($query);		 
			$xml_data = new SimpleXMLElement('<?xml version="1.0"?><data></data>');

			// function call to convert array to xml
			$this->array_to_xml($result,$xml_data);

			//saving generated xml file; 
			return $xml_data->asXML();
		}
		catch (Exception $e)
		{
			Mage::logException($e);
			return "<error>".$this->MakePrettyException($e)."</error>";
		}	
	}
   
	public function productOptionList($xmlConfigBase="")
	{
		if (!$this->isAPI())
		{
			$this->appendLog('productOptionList only available through API');
			return "<error>not API</error>";
		}

		try
		{
			$websiteIdStr = "1";
			$storeViewStr = "0";
			$pagination = "";

			if (strlen($xmlConfigBase) > 0)
			{
				$XMLobj = simplexml_load_string($xmlConfigBase);

				$websiteId = $XMLobj->xpath("//*[name() = 'websiteId']");
				$websiteIdStr = (string)$websiteId[0][0];

				$storeView = $XMLobj->xpath("//*[name() = 'storeView']");
				$storeViewStr = (string)$storeView[0][0];

				$limit = $XMLobj->xpath("//*[name() = 'limit']");
				$limitStr = (string)$limit[0][0];

				$offset = $XMLobj->xpath("//*[name() = 'offset']");
				$offsetStr = (string)$offset[0][0];

				if (strlen($limitStr) > 0 && strlen($offsetStr) > 0)
				{
					$pagination = " limit " . $limitStr . " offset " . $offsetStr;
				}
			}

			$prefix = Mage::getConfig()->getTablePrefix();
			$resource = Mage::getSingleton('core/resource');
			$readConnection = $resource->getConnection('core_read');

			$query = " select p.entity_id as sourceId, p.sku, type.title as type, value.title as value ".
					"  from (select * from ".$prefix."catalog_product_entity pb ".
					"        inner join ".$prefix."catalog_product_website ps on ps.product_id = pb.entity_id ".
					"           and ps.website_id = '".$websiteIdStr."') as p ".
					"   inner join ".$prefix."catalog_product_option relation on relation.product_id = p.entity_id ".
					"   inner join ".$prefix."catalog_product_option_type_value base on relation.option_id = base.option_id ".
					"   inner join ".$prefix."catalog_product_option_type_title value ".
					"        on base.option_type_id = value.option_type_title_id and value.store_id = '".$storeViewStr."' ".
					"   inner join ".$prefix."catalog_product_option_title type ".
					"        on base.option_id = type.option_id and type.store_id = '".$storeViewStr."' ".
					"  where p.type_id = 'simple' and p.has_options = 1 ". $pagination;

			$result = $readConnection->fetchAll($query);

			$xml_data = new SimpleXMLElement('<?xml version="1.0"?><data></data>');
			$this->array_to_xml($result,$xml_data);

			return $xml_data->asXML();
		}
		catch (Exception $e)
		{
			Mage::logException($e);
			return "<error>".$this->MakePrettyException($e)."</error>";
		}
	}
   
	public function orderConfirm($xmlOrder)
	{
		if (!$this->isAPI())
		{
			$this->appendLog('orderConfirm only available through API');
			return "<error>not API</error>";
		}		

		try
		{
			$orderXMLobj = simplexml_load_string($xmlOrder);

			$xmlOrderIdItem = $orderXMLobj->xpath("//*[name() = 'order_id']");
			$xmlOrderId = (string)$xmlOrderIdItem[0][0];

			$order = Mage::getModel('sales/order')->loadByIncrementId($xmlOrderId);

			if (is_null($order))
			{
				$this->appendLog('order not found for orderConfirm');
				return "<error>order not found</error>";
			}


			$xmlOrderNewStateItem = $orderXMLobj->xpath("//*[name() = 'magentoApprovedState']");
			$xmlOrderNewState = (string)$xmlOrderNewStateItem[0][0];

			$xmlOrderNewStatusItem = $orderXMLobj->xpath("//*[name() = 'magentoApprovedStatus']");
			$xmlOrderNewStatus = (string)$xmlOrderNewStatusItem[0][0];

			if ($xmlOrderNewState == "")
			{
				if (!$order->canInvoice()) 
				{
					$this->appendLog('order cannot invoice for orderConfirm');
					return "<error>false</error>";
				}

				$savedQtys = array();
				$invoice = Mage::getModel('sales/service_order', $order)->prepareInvoice($savedQtys);
				if (!$invoice->getTotalQty()) 
				{
					return "<error>false</error>";
				}
				$invoice->setRequestedCaptureCase(Mage_Sales_Model_Order_Invoice::CAPTURE_OFFLINE);
				$invoice->register();

				$invoice->getOrder()->setCustomerNoteNotify(false);
				$invoice->getOrder()->setIsInProcess(true);

				$transactionSave = Mage::getModel('core/resource_transaction')
					->addObject($invoice)
					->addObject($invoice->getOrder());

				$transactionSave->save();
			}
			else
			{
				$order->setStatus($xmlOrderNewStatus);
				$order->setState($xmlOrderNewState);
				$history = $order->addStatusHistoryComment('Confirm. - Hub2b', false);
				$history->setIsCustomerNotified(false);

				$order->save();
			}
			
			return "<success>true</success>";
		}
		catch (Exception $e)
		{
			Mage::logException($e);
			return "<error>".$response.$this->MakePrettyException($e)."</error>";
		}
	}
   
	public function orderCancel($xmlOrder)
	{
		if (!$this->isAPI())
		{
			$this->appendLog('orderCancel only available through API');
			return "<error>not API</error>";
		}		

		try
		{
			$orderXMLobj = simplexml_load_string($xmlOrder);

			$xmlOrderIdItem = $orderXMLobj->xpath("//*[name() = 'order_id']");
			$xmlOrderId = (string)$xmlOrderIdItem[0][0];

			$order = Mage::getModel('sales/order')->loadByIncrementId($xmlOrderId);

			if (is_null($order))
			{
				$this->appendLog('order not found for orderCancel');
				return "<error>order not found</error>";
			}

			$xmlOrderNewStateItem = $orderXMLobj->xpath("//*[name() = 'magentoCancelState']");
			$xmlOrderNewState = (string)$xmlOrderNewStateItem[0][0];

			$xmlOrderNewStatusItem = $orderXMLobj->xpath("//*[name() = 'magentoCancelStatus']");
			$xmlOrderNewStatus = (string)$xmlOrderNewStatusItem[0][0];

			if ($xmlOrderNewState == "")
			{
				if(!$order->canCancel())
				{
					$this->appendLog('order cannot cancel by orderCancel');
					return "<error>cant cancel</error>";
				}

				$order->cancel();
				
				$xmlOrderNewState = "canceled";
				$xmlOrderNewStatus = "canceled";
			}
			
			$order->setStatus($xmlOrderNewStatus);
			$order->setState($xmlOrderNewState);
			$history = $order->addStatusHistoryComment('Cancel. - Hub2b', false);
			$history->setIsCustomerNotified(false);

			$order->save();

			// Finished
			return "<success>true</success>";
		}
		catch (Exception $e)
		{
			Mage::logException($e);
			return "<error>".$response.$this->MakePrettyException($e)."</error>";
		}
	}  
   
	public function createorder($quoteObj, $status, $orderXMLobj)
	{
		$service = Mage::getModel('sales/service_quote', $quoteObj);

		$service->submitAll();

		$order = $service->getOrder();

		if (is_null($order))
		{
			throw new Exception("The order was not created for unknown reasons. Please, check magento_path/var/log/hub2b.log for more information.");
		}

		$increment_id = $order->getRealOrderId();

		$commentItem = $orderXMLobj->xpath("//*[name() = 'comment']");
		$comment = $commentItem[0][0];

		if ($comment != "")
		{
			$order->addStatusHistoryComment($comment);
			$order->save();
		}

		if (in_array($status, array('3', '4', '5', '6')))
		{
			$xmlOrderNewStateItem = $orderXMLobj->xpath("//*[name() = 'magentoApprovedState']");
			$xmlOrderNewState = (string)$xmlOrderNewStateItem[0][0];

			$xmlOrderNewStatusItem = $orderXMLobj->xpath("//*[name() = 'magentoApprovedStatus']");
			$xmlOrderNewStatus = (string)$xmlOrderNewStatusItem[0][0];
			
			if ($xmlOrderNewState == "")
			{
				//paid
				if (!$order->canInvoice()) 
				{
					$this->appendLog('order cannot invoice for createOrder');
					return false;
				}

				$savedQtys = array();
				$invoice = Mage::getModel('sales/service_order', $order)->prepareInvoice($savedQtys);

				if (!$invoice->getTotalQty()) 
				{
					$this->appendLog('invoice has no totalQty while preparingInvoice');
					return false;
				}

				$invoice->setRequestedCaptureCase(Mage_Sales_Model_Order_Invoice::CAPTURE_OFFLINE);
				$invoice->register();

				try
				{
					$invoice->getOrder()->setCustomerNoteNotify(true);
				}
				catch (Exception $enotify)
				{
					Mage::logException($enotify);
					$this->appendLog('Error notifying customer about order. Ignoring error.');
				}
				
				$invoice->getOrder()->setIsInProcess(true);

				$transactionSave = Mage::getModel('core/resource_transaction')
					->addObject($invoice)
					->addObject($invoice->getOrder());

				$transactionSave->save();
			}
			else
			{
				$order->setStatus($xmlOrderNewStatus);
				$order->setState($xmlOrderNewState);
				$history = $order->addStatusHistoryComment('Confirm. - Hub2b', false);
				$history->setIsCustomerNotified(false);

				$order->save();
			}
			
		}
		
		return $increment_id;
	}
   
	public function updateOrderQuoteWithSourceReference()
	{
	try
		{
			$resource = Mage::getSingleton('core/resource');
			$readConnection = $resource->getConnection('core_read');
			$tableName = $resource->getTableName('sales/order');
			$saleafield = $readConnection->describeTable($tableName);

			$orderCustomFields = array('source_order_number', 'source_store', 'shipping_estimate_days', 'source_sales_channel', 'payment_method', 'payment_installments');
			$orderCustomFieldsToCreate = array();

			foreach($orderCustomFields as $fieldName)
			if ($saleafield[$fieldName] == null)
			array_push($orderCustomFieldsToCreate, $fieldName);

			if (count($orderCustomFieldsToCreate) > 0)
			{
				$installer = new Mage_Sales_Model_Mysql4_Setup('hub2b_customapi');
				$attribute = array(
				'type'          => 'varchar',
				'backend_type'  => 'varchar',
				'frontend_input' => 'varchar',
				'is_user_defined' => true,
				'label'         => '',
				'visible'       => false,
				'required'      => false,
				'user_defined'  => true,
				'searchable'    => false,
				'filterable'    => false,
				'comparable'    => false,
				'default'       => null
				);

				foreach($orderCustomFieldsToCreate as $fieldName)
				{
					$installer->addAttribute('order', $fieldName, $attribute);
					$installer->addAttribute('quote', $fieldName, $attribute);
				}

				$installer->endSetup();
			}
		}
		catch (Exception $customFieldsException)
		{ 
			Mage::logException($customFieldsException);
		}
	}
   
	private function getCustomer($taxvat, $email, $websiteId)
	{
		$this->appendLog('customer cnpj/cpf: ' . (string)$taxvat);
		$this->appendLog('customer email: ' . (string)$email);

		$customer = Mage::getModel('customer/customer')
			->getCollection()
			->addAttributeToFilter('taxvat', array('eq' => $taxvat))
			->addAttributeToSelect('taxvat')
				->load()
				->getFirstItem();
			
		if (is_null($customer->getId()))
		{
			$this->appendLog('Customer was not found by cnpj/cpf, trying with email..');

			$customer = Mage::getModel('customer/customer')
				->setWebsiteId($websiteId)
				->loadByEmail($email);
		}
		else
			$this->appendLog('Customer found by cnpj/cpf');

		return $customer;
	}

	private function eavAttributeCodeExists($entity_type_code, $attribute_code)
	{
		$attr = Mage::getResourceModel('catalog/eav_attribute')->loadByCode($entity_type_code, $attribute_code);
		return !is_null($attr) && (string)$attr->getId() != "";
	}

	private function trySetDataEav($reference, $entity_type_code, $eav_code, $description, $value)
	{
		if ($value != "" && $this->eavAttributeCodeExists($entity_type_code, $eav_code))
		{
			$reference->setData($eav_code, $value);

			$this->appendLog($entity_type_code . ' ' . $description . ' was set: ' . $value);
		}
		else
			$this->appendLog($entity_type_code  . ' ' .  $description . ' was empty or eav code did not exist.');
	}

	public function orderCreate($xmlOrder)
	{
		if (!$this->isAPI())
		{
			$this->appendLog('orderCreate only available through API');
			return "<error>not API</error>";
		}

		try 
		{
			$this->appendLog('------------ ' . date('D M d, Y G:i') . ' ------------');
			$this->appendLog('orderCreate started');
            
            $this->updateOrderQuoteWithSourceReference();
            
			$version = Mage::getVersionInfo();
			$strVersion = '';

			foreach ($version as $key => $value)
				$strVersion .= ('.' . $value);

			$this->appendLog('Magento version: ' . $strVersion);
			
			$this->appendLog('Hub2b Extension version: ' . $this->version());
			
			$this->appendLog('Preparing to create new Order!');

			$orderXMLobj = simplexml_load_string($xmlOrder);

			$this->appendLog('Order payload was correctly parsed.');

			$orderNumberItem = $orderXMLobj->xpath("//*[name() = 'orderNumber']");
			$orderNumber = (string)$orderNumberItem[0][0];			
			
			$existingOrder = $this->getExistingOrder($orderNumber);
			
			if($existingOrder != "")
				return $existingOrder;			
			
			$sourceStoreItem = $orderXMLobj->xpath("//*[name() = 'sourceStore']");
			$sourceStore = (string)$sourceStoreItem[0][0];

			$sourceSalesChannelItem = $orderXMLobj->xpath("//*[name() = 'sourceSalesChannel']");
			$sourceSalesChannel = (string)$sourceSalesChannelItem[0][0];
		
			$xmlStoreIdItem = $orderXMLobj->xpath("//*[name() = 'store_id']");
			$storeId = (string)$xmlStoreIdItem[0][0];

			$xmlIsGuestItem = $orderXMLobj->xpath("//*[name() = 'customer_is_guest']"); 			
			$isGuest = (string)$xmlIsGuestItem[0][0];			

			if (strlen($storeId) > 0)
				Mage::app()->setCurrentStore($storeId);
			else
			{
				Mage::app()->setCurrentStore(Mage_Core_Model_App::ADMIN_STORE_ID);
				$storeId = Mage::app()->getStore()->getStoreId();
			}

			$websiteId = Mage::app()->getStore()->getWebsiteId();

			$this->appendLog('Store: ' . $storeId . ' Website: ' . $websiteId);

			$firstNameItem = $orderXMLobj->xpath("//*[name() = 'customer_firstname']");
			$firstname = (string)$firstNameItem[0][0];
			$lastnameItem = $orderXMLobj->xpath("//*[name() = 'customer_lastname']");
			$lastname = (string)$lastnameItem[0][0];
			$midnameItem = $orderXMLobj->xpath("//*[name() = 'customer_middlename']");
			$midname = (string)$midnameItem[0][0];
			$custemailItem = $orderXMLobj->xpath("//*[name() = 'customer_email']");
			$custemail = (string)$custemailItem[0][0];
			$custdocnumberItem = $orderXMLobj->xpath("//*[name() = 'customer_docnumber']");
			$custdocnumber = (string)$custdocnumberItem[0][0];
			$custbdayItem = $orderXMLobj->xpath("//*[name() = 'customer_birthday']");
			$custbday = (string)$custbdayItem[0][0];
			$password = trim($firstname).trim($lastname)."*999";

			$customerGroupItem = $orderXMLobj->xpath("//*[name() = 'customer_group_id']");
			$customerGroup = (string)$customerGroupItem[0][0];
			if ($customerGroup == "")
				$customerGroup = 1;

			
			$quoteObj = Mage::getModel('sales/quote');
			
			if($isGuest == '0')
			{
				$customer = $this->getCustomer($custdocnumber, $custemail, $websiteId);

				if(is_null($customer->getId()))
				{
					$this->appendLog('Customer not found, going to create.');

					$customer = Mage::getModel("customer/customer");

					$customer->setWebsiteId($websiteId)
						->setStoreId($storeId)
						->setGroupId($customerGroup)
						->setPrefix('')
						->setFirstname($firstname)
						->setMiddleName($midname)
						->setLastname($lastname)
						->setSuffix('')
						->setEmail($custemail)
						->setPassword($password);
					$this->appendLog('customer base info were set.');

					$this->trySetDataEav($customer, 'customer', 'dob', 'date of birth (dob)', $custbday);
					$tipopessoa = "fisica";
					if (strlen($custdocnumber) > 11)
						$tipopessoa = "juridica";
					$this->trySetDataEav($customer, 'customer', 'tipopessoa', 'tipopessoa', $tipopessoa);

					$this->trySetDataEav($customer, 'customer', 'taxvat', 'CPF/CNPJ (taxvat)', $custdocnumber);

					try
					{
						$customer->save();
						$this->appendLog('customer saved successfully');
					}
					catch (Exception $e) 
					{
						Mage::logException($e);
						$this->appendLog($this->MakePrettyException($e));
						return '<error>' . $this->m_LOG . '</error>';
					}
				}
				else
					$this->appendLog('Customer found, using the same...');

				$quoteObj->assignCustomer($customer);
				$this->appendLog('Customer assigned to quote.');
				
				$quoteObj->setCustomerIsGuest(false);
			}
			else		
			{				
				$quoteObj->setCustomerIsGuest(true)
					->setCheckoutMethod('guest')
					->setCustomerId(null)
					->setCustomerGroupId(Mage_Customer_Model_Group::NOT_LOGGED_IN_ID);
				
				$this->appendLog('Customer: Guest.');
			}
			
			$storeObj = $quoteObj->getStore()->load($storeId);
			$this->appendLog('Store: ' . (string)$storeId);

			$this->appendLog('load store from quote');
			$quoteObj->setStore($storeObj);
			$this->appendLog('store was set to quote');
			//force set name
			$quoteObj->setCustomerEmail($custemail);
			$quoteObj->setCustomerFirstname($firstname);
			$quoteObj->setCustomerLastname($lastname);
			$this->appendLog('quote: additional info updated to customer');
			// --------------------

			$quoteObj->setIsSuperMode(true);
			$this->appendLog('supermode set true');
			
			$arrayProducts = $orderXMLobj->xpath("//*[name() = 'product']");
			$this->appendLog('product xmllist loaded.');

			$totalWeight = 0;
			
			foreach($arrayProducts as $node)
			{
				$productXMLobj = simplexml_load_string($node->asXML());
				$this->appendLog('xmllist product object parsed successfully.');

				$skuItem = $productXMLobj->xpath("//*[name() = 'sku']");
				$sku = (string)$skuItem[0][0];
				$qtyItem = $productXMLobj->xpath("//*[name() = 'qty']");
				$qty = (string)$qtyItem[0][0];
				$priceItem = $productXMLobj->xpath("//*[name() = 'price']");
				$price = (string)$priceItem[0][0];

				$productId = Mage::getModel('catalog/product')->getIdBySku($sku);
				if (!$productId)
				{
					$this->appendLog('Sku ' . $sku . ' does not exist!');
					return '<error>' . $this->m_LOG . '</error>';
				}
				$this->appendLog('Product was found.');
				$productObj = Mage::getModel('catalog/product')->setStore($storeObj)->setStoreId($storeId)->load($productId);
				$this->appendLog('Product loaded from store_id: ' . (string)$storeId);
				
				$productObj->setSkipCheckRequiredOption(true);
				$this->appendLog('skipped check requirement option');

				try
				{
					$totalWeight += $productObj->getWeight();
					
					if ($version['major'] == 1 && $version['minor'] == 9 && $version['revision'] >= 0)
					{
						$this->appendLog('SKU being added above 1.9.0+');
						
						$this->appendLog('Product ' . $sku . ', weight: '. $productObj->getWeight() . ', price: '. $price . ' found and added to cart as expected.');
						
						$quoteItem = $quoteObj->addProduct($productObj);
						$quoteItem->setQty($qty);
						$quoteItem->setWeight($productObj->getWeight());
						$quoteItem->setQuote($quoteObj);
						$quoteObj->addItem($quoteItem);
						
						$productObj->unsSkipCheckRequiredOption();
						$quoteItem->checkData();
					}
					else 
					{
						$this->appendLog('SKU being added below 1.9.0');
						
						$this->appendLog('Product ' . $sku . ', weight: '. $productObj->getWeight() . ', price: '. $price . ' found and added to cart as expected.');
						
						$quoteObj->addProduct($productObj, new Varien_Object(array('qty' => $qty)));
						$productObj->unsSkipCheckRequiredOption();
					}
				} 
				catch (exception $e) 
				{
					Mage::logException($e);
					$this->appendLog($this->MakePrettyException($e));
					return "<error>" . $this->m_LOG . "</error>";
				}
			}

			$quoteObj->save();

			$quoteObj = Mage::getModel("sales/quote")->load($quoteObj->getId()); 

			foreach($arrayProducts as $node)
			{
				$productXMLobj = simplexml_load_string($node->asXML());

				$skuItem = $productXMLobj->xpath("//*[name() = 'sku']");
				$sku = (string)$skuItem[0][0];
				$qtyItem = $productXMLobj->xpath("//*[name() = 'qty']");
				$qty = (string)$qtyItem[0][0];
				$priceItem = $productXMLobj->xpath("//*[name() = 'price']");
				$price = (string)$priceItem[0][0];

				$productId = Mage::getModel('catalog/product')->getIdBySku($sku);
				if (!$productId)
				{
					$this->appendLog('Sku ' . $sku . ' does not exist!');
					return '<error>' . $this->m_LOG . '</error>';
				}
				$this->appendLog('Product was found.');
				$productObj = Mage::getModel('catalog/product')->setStore($storeObj)->setStoreId($storeId)->load($productId);
				$this->appendLog('Product loaded from store_id: ' . (string)$storeId);
				
				
				$productObj->setSkipCheckRequiredOption(true);

				try
				{
					$this->appendLog('Product ' . $sku . ', weight: '. $productObj->getWeight() . ', price: '. $price . ' found and added to cart as expected.');
					
					$quoteItem = $quoteObj->getItemByProduct($productObj);
					
					if ($quoteItem !== false)
					{
						$quoteItem->setOriginalCustomPrice($price);
						$quoteItem->setCustomPrice($price);
						$quoteItem->setWeight($productObj->getWeight());
						$quoteItem->setIsSuperMode(true);
						$quoteItem->save();
					}
				} 
				catch (exception $e) 
				{
					Mage::logException($e);
					$this->appendLog($this->MakePrettyException($e));
					return "<error>" . $this->m_LOG . "</error>";
				}

				$productObj->unsSkipCheckRequiredOption();
			}

			// ##################		

			$streetItem = $orderXMLobj->xpath("//*[name() = 'shipping_address_street']");
			$street = (string)$streetItem[0][0];
			$cityItem = $orderXMLobj->xpath("//*[name() = 'shipping_address_city']");
			$city = (string)$cityItem[0][0];
			$neighborhoodItem = $orderXMLobj->xpath("//*[name() = 'shipping_address_neighborhood']");
			$neighborhood = (string)$neighborhoodItem[0][0];
			$postcodeItem = $orderXMLobj->xpath("//*[name() = 'shipping_address_postcode']");
			$postcode = (string)$postcodeItem[0][0];
			$telephoneItem = $orderXMLobj->xpath("//*[name() = 'shipping_address_telephone']");
			$telephone = (string)$telephoneItem[0][0];
			$mobileItem = $orderXMLobj->xpath("//*[name() = 'shipping_address_mobile']");
			$mobile = (string)$mobileItem[0][0];			
			$country_idItem = $orderXMLobj->xpath("//*[name() = 'shipping_address_country_id']");
			$country_id = (string)$country_idItem[0][0];
			$regionItem = $orderXMLobj->xpath("//*[name() = 'shipping_address_region']");
			$region = (string)$regionItem[0][0];
			$regionidItem = $orderXMLobj->xpath("//*[name() = 'shipping_address_region_id']");
			$regionid = (string)$regionidItem[0][0];
			$addressnumberItem = $orderXMLobj->xpath("//*[name() = 'shipping_address_number']");
			$addressnumber = (string)$addressnumberItem[0][0];
			$addresscomplementItem = $orderXMLobj->xpath("//*[name() = 'shipping_address_complement']");
			$addresscomplement = (string)$addresscomplementItem[0][0];
			$receiverFirstNameItem = $orderXMLobj->xpath("//*[name() = 'shipping_address_receiver_firstname']");
			$receiverFirstName = (string)$receiverFirstNameItem[0][0];
			$receiverLastNameItem = $orderXMLobj->xpath("//*[name() = 'shipping_address_receiver_lastname']");
			$receiverLastName = (string)$receiverLastNameItem[0][0];

			if ($receiverFirstName == "")
				$receiverFirstName = $firstname;
			if ($receiverLastName == "")
				$receiverLastName = $lastname;

			$billingstreetItem = $orderXMLobj->xpath("//*[name() = 'billing_address_street']");
			$billingstreet = (string)$billingstreetItem[0][0];
			$billingneighborhoodItem = $orderXMLobj->xpath("//*[name() = 'billing_address_neighborhood']");
			$billingneighborhood = (string)$billingneighborhoodItem[0][0];
			$billingcityItem = $orderXMLobj->xpath("//*[name() = 'billing_address_city']");
			$billingcity = (string)$billingcityItem[0][0];
			$billingpostcodeItem = $orderXMLobj->xpath("//*[name() = 'billing_address_postcode']");
			$billingpostcode = (string)$billingpostcodeItem[0][0];
			$billingtelephoneItem = $orderXMLobj->xpath("//*[name() = 'billing_address_telephone']");
			$billingtelephone = (string)$billingtelephoneItem[0][0];
			$billingmobileItem = $orderXMLobj->xpath("//*[name() = 'billing_address_mobile']");
			$billingmobile = (string)$billingmobileItem[0][0];			
			$billingcountry_idItem = $orderXMLobj->xpath("//*[name() = 'billing_address_country_id']");
			$billingcountry_id = (string)$billingcountry_idItem[0][0];
			$billingregionItem = $orderXMLobj->xpath("//*[name() = 'billing_address_region']");
			$billingregion = (string)$billingregionItem[0][0];
			$billingregionidItem = $orderXMLobj->xpath("//*[name() = 'billing_address_region_id']");
			$billingregionid = (string)$billingregionidItem[0][0];
			$billingaddressnumberItem = $orderXMLobj->xpath("//*[name() = 'billing_address_number']");
			$billingaddressnumber = (string)$billingaddressnumberItem[0][0];
			$billingaddresscomplementItem = $orderXMLobj->xpath("//*[name() = 'billing_address_complement']");
			$billingaddresscomplement = (string)$billingaddresscomplementItem[0][0];

			$_billing_address = array(
				'customer_address_id' => '',
				'prefix' => '',
				'firstname' => $firstname,
				'middlename' => $midname,
				'lastname' => $lastname,
				'suffix' => '',
				'company' =>'', 
				'street' => array(
					'0' => $billingstreet,
					'1' => $billingaddressnumber,
					'2' => $billingaddresscomplement,
					'3' => $billingneighborhood),
				'city' => $billingcity,
				'country_id' => $billingcountry_id,
				'region' => $billingregion,
				'region_id' => $billingregionid,
				'postcode' => $billingpostcode,
				'telephone' => $billingtelephone,
				'fax' => $billingmobile,
				'vat_id' => ''
			);

			$_shipping_address = array(
				'customer_address_id' => '',
				'prefix' => '',
				'firstname' => $receiverFirstName,
				'middlename' => '',
				'lastname' => $receiverLastName,
				'suffix' => '',
				'company' =>'', 
				'street' => array(
					'0' => $street,
					'1' => $addressnumber,
					'2' => $addresscomplement,
					'3' => $neighborhood),
				'city' => $city,
				'country_id' => $country_id,
				'region' => $region,
				'region_id' => $regionid,
				'postcode' => $postcode,
				'telephone' => $telephone,
				'fax' => $mobile,
				'vat_id' => '',
				'use_for_shipping' => '1'
			);

			$shippingPriceItem = $orderXMLobj->xpath("//*[name() = 'shipping_amount']");
			$shippingPrice = (string)$shippingPriceItem[0][0];

			$shippingProviderItem = $orderXMLobj->xpath("//*[name() = 'shippingProvider']");
			$shippingProvider = (string)$shippingProviderItem[0][0];

			$shippingServiceItem = $orderXMLobj->xpath("//*[name() = 'shippingService']");
			$shippingService = (string)$shippingServiceItem[0][0];

			$shippingEstimateDaysItem = $orderXMLobj->xpath("//*[name() = 'shipping_estimate_days']");
			$shippingEstimateDays = (string)$shippingEstimateDaysItem[0][0];			
			
			$paymentMethodItem = $orderXMLobj->xpath("//*[name() = 'paymentMethod']");
			$paymentMethod = (string)$paymentMethodItem[0][0];				

			$paymentInstallmentsItem = $orderXMLobj->xpath("//*[name() = 'paymentInstallments']");
			$paymentInstallments = (string)$paymentInstallmentsItem[0][0];				
			
			$sessionId = Mage::getSingleton('api/session')->getSessionId();
			
			if($isGuest == '0')
			{
				$customerAddressesId = $customer->getAddresses();
			
				foreach($customerAddressesId as $key => $val)
				{					
					$addressExists = true;

					$customerAddress = $customer->getAddressItemById($key);

					$addressStreet =  $customerAddress->getData('street');
					$addressPostcode =  $customerAddress->getData('postcode');
					
					$pos = strpos($addressStreet, $street);

					if($pos === false && ($postcode != $addressPostcode))
						$addressExists = false;	

					if($addressExists == true)
						$customerAddress->delete();						
				}

				$customAddressBilling = Mage::getModel('customer/address');

				$customAddressBilling->setData($_billing_address)
				   	->setCustomerId($customer->getId())
					->setIsDefaultBilling('1')
					->setIsDefaultShipping('0')
					->setSaveInAddressBook('0');
			
				try 
				{
					$this->appendLog('Setting up billing address.');
					$customAddressBilling->save();
					$this->appendLog('Billing address set as expected.');
				}
				catch (Exception $ex) 
				{
					Mage::logException($ex);
					$this->appendLog($this->MakePrettyException($ex));
					return "<error>" . $this->m_LOG . "</error>";
				}
				$customAddress = Mage::getModel('customer/address');

				$customAddress->setData($_shipping_address)
					->setCustomerId($customer->getId())
					->setIsDefaultBilling('0')
					->setIsDefaultShipping('1')
					->setSaveInAddressBook('0');
			
				try 
				{
					$this->appendLog('Setting up shipping address.');
					$customAddress->save();
					$this->appendLog('Shipping address set as expected.');
				}
				catch (Exception $ex) 
				{
					Mage::logException($ex);
					$this->appendLog($this->MakePrettyException($ex));
					return "<error>" . $this->m_LOG . "</error>";
				}
				//Set Sales Order Billing/Shipping Addresses
				$this->appendLog('Importing billing address.');
				$billingAddress = $quoteObj->getBillingAddress()->importCustomerAddress($customAddressBilling);
				$this->appendLog('Billing address imported as expected.');
				$this->appendLog('Importing shipping address.');
				$shippingAddress = $quoteObj->getShippingAddress()->importCustomerAddress($customAddress);
				$this->appendLog('Shipping address imported as expected.');
				// ################################
				
			}
			else
			{
				//Set Sales Order Billing/Shipping Addresses
				$this->appendLog('Set billing address.');
				$quoteObj->getBillingAddress()
					->addData($_billing_address)
					->setIsDefaultBilling('1')
					->setIsDefaultShipping('0')
					->setSaveInAddressBook('0');
		
				$this->appendLog('Billing address set as expected.');
				$this->appendLog('Set shipping address.');
										
				$shippingAddress = $quoteObj->getShippingAddress()->addData($_shipping_address);		
										
				$this->appendLog('Shipping address set as expected.');									
			}

			try
			{
				if (Mage::registry('customShippingInfo' . $sessionId) != NULL)
					Mage::unregister('customShippingInfo' . $sessionId);
				Mage::register('customShippingInfo' . $sessionId, array('provider' => $shippingProvider, 'service' => $shippingService, 'price' => $shippingPrice));

				$this->appendLog('Going to collect shippinng rates based on shipping address.');
						
				$quoteObj->setCollectShippingRates(true); 
				$shippingAddress->setWeight($totalWeight)
					->setCollectShippingRates(true)
					->collectShippingRates()
					->collectTotals()
					->setShippingMethod($shippingProvider . '_' . $shippingService);

				
				$shippingRates = $shippingAddress->getShippingRatesCollection();				
				foreach ($shippingRates as $rate)
				{
					$formattedPrice = Mage::helper('core')->currency($rate->getPrice(), true, false);
					$strRate = '->'.$rate->getMethodTitle().'('.$rate->getCode().'): '.$formattedPrice;

					$this->appendLog($strRate);
				}				
			
				$quoteObj->save();				

				$this->appendLog('collectShippingRates result: ' . (is_null($shippingRates) ? 'Failed!' : 'done.'));

				Mage::unregister('customShippingInfo' . $sessionId);
			}
			catch (Exception $e)
			{
				Mage::logException($e);
				$this->appendLog($this->MakePrettyException($e));
				return "<error>" . $this->m_LOG . "</error>";
			}

			//Set quote object's payment method to check / money order to allow progromatic entries of orders 
			//(kind of hard to programmatically guess and enter a customer's credit/debit cart so only money orders are allowed to be entered via api) 

			$this->appendLog('Going to import payment to cart..');
			$quoteObj->getPayment()->importData(array('method' => 'hubpayment'));
			$this->appendLog('Payment imported to cart..');

			$quoteObj->collectTotals()->save();
			$this->appendLog('Totals of cart were updated sucessfully.');

			$statusItem = $orderXMLobj->xpath("//*[name() = 'status']");
			$status = (string)$statusItem[0][0];

			$this->appendLog('Going to create the Order...');
			$increment_id = self::createOrder($quoteObj, $status, $orderXMLobj);
			$this->appendLog('Order created: ' . $increment_id);
			
			//Create custom fields if it does not exist:
			//sales_flat_order.source_order_number
			//sales_flat_order.source_store

			$this->appendLog('Começando limpeza do carrinho.');			
			$quoteObj->setIsActive(false)->save();
			Mage::getSingleton('checkout/session')->clear();
			$this->appendLog('Limpeza do carrinho compĺeta');

			try
			{
				$this->appendLog('Updating custom fields: source_order_number and source_store.');

				$order = Mage::getModel('sales/order')->loadByIncrementId($increment_id);
				$order->setsource_order_number($orderNumber);
				$order->setsource_store($sourceStore);
				$order->setshipping_estimate_days($shippingEstimateDays);
				$order->setsource_sales_channel($sourceSalesChannel);
				$order->setpayment_method($paymentMethod);
				$order->setpayment_installments($paymentInstallments);
				
				$order->save();
			}
			catch(Exception $srcRefException)
			{ 
				Mage::logException($srcRefException);
				$this->appendLog($this->MakePrettyException($srcRefException));
			}

			return $increment_id;
		}
		catch (Exception $e)
		{
			Mage::logException($e);
			$this->appendLog($this->MakePrettyException($e));
			return "<error>".$this->m_LOG."</error>";
		}
	}
   

	public function salesOrderCreate($xmlOrder)
	{
		if (!$this->isAPI())
		{
			$this->appendLog('salesOrderCreate only available through API');
			return "<error>not API</error>";
		}

		$this->appendLog('------------ ' . date('D M d, Y G:i') . ' ------------');
		$this->appendLog('salesOrderCreate started');

		try
		{
		
			$orderHub = $this->prepareOrder($xmlOrder);
						
			$existingOrder = $this->getExistingOrder($orderHub['orderNumber']);
					
			if($existingOrder != "")
				return $existingOrder;
			
			$websiteId = Mage::getModel('core/store')
				->load($orderHub['store_id'])
				->getWebsiteId();

			if($orderHub['isGuest'] == 0)
			{								
				$this->appendLog('Retrieving customer...');
				$customer = $this->getCustomer($orderHub['custdocnumber'], $orderHub['custemail'], $websiteId);

				if(is_null($customer->getId()))
				{
					$customerGroup = $orderHub['customer_group_id'];
					if ($customerGroup == "")
						$customerGroup = 1;

					$this->appendLog('Customer did not exist, creating a new one...');
					$customer = Mage::getModel("customer/customer")
						->setWebsiteId($websiteId)
						->setStoreId($orderHub['store_id'])
						->setGroupId($customerGroup)
						->setPrefix('')
						->setFirstname($orderHub['firstname'])
						->setMiddleName($orderHub['midname'])
						->setLastname($orderHub['lastname'])
						->setSuffix('')
						->setEmail($orderHub['custemail'])
						->setConfirmation(null)
						->setPassword($orderHub['password']);

					if ($orderHub['custbday'] != "")
					   $customer->setData('dob',$orderHub['custbday']);

					$tipopessoa = (strlen($orderHub['custdocnumber']) > 11 ? "juridica" : "fisica");
					$customer->setData('tipopessoa',$tipopessoa);
					$customer->setData('taxvat',$orderHub['custdocnumber']);

					$customer->save();
				}
				else
					$this->appendLog('Customer found, using the same...');
				
				$transaction = Mage::getModel('core/resource_transaction');

				$this->appendLog('Setting up currencies and store to the order...');
				$currency_code = Mage::app()->getStore()->getCurrentCurrencyCode();
				$order = Mage::getModel('sales/order')
					->setStoreId($orderHub['store_id'])
					->setQuoteId(0)
					->setGlobal_currency_code($currency_code)
					->setBase_currency_code($currency_code)
					->setStore_currency_code($currency_code)
					->setOrder_currency_code($currency_code);

				$this->appendLog('Setting up customer to the order...');

						
				$order->setCustomer_email($customer->getEmail())
					->setCustomer_taxvat($orderHub['custdocnumber'])
					->setCustomerFirstname($customer->getFirstname())
					->setCustomerLastname($customer->getLastname())
					->setCustomerGroupId($customer->getGroupId())
					->setCustomer_is_guest(0)
					->setCustomer($customer);

				$this->appendLog('Creating customer billing address...');
				$billing = Mage::getModel('customer/address')
					->setData($orderHub['billing_address'])
					->setCustomerId($customer->getId())
					->setIsDefaultBilling('1')
					->setIsDefaultShipping('0')
					->setSaveInAddressBook('1')
					->save();

				$this->appendLog('Creating customer shipping address...');
				$shipping = Mage::getModel('customer/address')
					->setData($orderHub['shipping_address'])
					->setCustomerId($customer->getId())
					->setIsDefaultBilling('0')
					->setIsDefaultShipping('1')
					->setSaveInAddressBook('1')
					->save();

				$this->appendLog('Setting up billing address to the order...');
				$billingAddress = Mage::getModel('sales/order_address')
					->setStoreId($orderHub['store_id'])
					->setAddressType(Mage_Sales_Model_Quote_Address::TYPE_BILLING)
					->setCustomerId($customer->getId())
					->setCustomerAddressId($customer->getDefaultBilling())
					->setCustomer_address_id($billing->getEntityId())
					->setPrefix($billing->getPrefix())
					->setFirstname($orderHub['billing_address']['firstname'])
					->setMiddlename($orderHub['billing_address']['middlename'])
					->setLastname($orderHub['billing_address']['lastname'])
					->setSuffix($billing->getSuffix())
					->setCompany($billing->getCompany())
					->setStreet($billing->getStreet())
					->setCity($billing->getCity())
					->setCountry_id($billing->getCountryId())
					->setRegion($billing->getRegion())
					->setRegion_id($billing->getRegionId())
					->setPostcode($billing->getPostcode())
					->setTelephone($billing->getTelephone())
					->setFax($billing->getFax())
					->setEmail($orderHub['custemail']);
				$order->setBillingAddress($billingAddress);

				$this->appendLog('Setting up shipping address to the order...');
				$shippingAddress = Mage::getModel('sales/order_address')
					->setStoreId($orderHub['store_id'])
					->setAddressType(Mage_Sales_Model_Quote_Address::TYPE_SHIPPING)
					->setCustomerId($customer->getId())
					->setCustomerAddressId($customer->getDefaultShipping())
					->setCustomer_address_id($shipping->getEntityId())
					->setPrefix($shipping->getPrefix())
					->setFirstname($orderHub['shipping_address']['firstname'])
					->setMiddlename($orderHub['shipping_address']['middlename'])
					->setLastname($orderHub['shipping_address']['lastname'])
					->setSuffix($shipping->getSuffix())
					->setCompany($shipping->getCompany())
					->setStreet($shipping->getStreet())
					->setCity($shipping->getCity())
					->setCountry_id($shipping->getCountryId())
					->setRegion($shipping->getRegion())
					->setRegion_id($shipping->getRegionId())
					->setPostcode($shipping->getPostcode())
					->setTelephone($shipping->getTelephone())
					->setFax($shipping->getFax())
					->setEmail($orderHub['custemail']);		
			}
			else
			{
				$transaction = Mage::getModel('core/resource_transaction');

				$this->appendLog('Setting up currencies and store to the order...');
				$currency_code = Mage::app()->getStore()->getCurrentCurrencyCode();

				$order = Mage::getModel('sales/order')
					->setStoreId($orderHub['store_id'])
					->setQuoteId(0)
					->setGlobal_currency_code($currency_code)
					->setBase_currency_code($currency_code)
					->setStore_currency_code($currency_code)
					->setOrder_currency_code($currency_code);

				$this->appendLog('Setting up guest customer to the order...');
						
				$order->setCustomer_email($orderHub['custemail'])
					->setCustomer_taxvat($orderHub['custdocnumber'])
					->setCustomerFirstname($orderHub['firstname']) 
					->setCustomerLastname($orderHub['lastname'])
					->setCustomerGroupId(Mage_Customer_Model_Group::NOT_LOGGED_IN_ID)
					->setCustomer_is_guest(1)
				 	->setCustomerId(null)
					->setCustomerIsGuest(true);

				$this->appendLog('Creating billing address...');
				$billing = Mage::getModel('customer/address')
					->setData($orderHub['billing_address']);

				$this->appendLog('Creating shipping address...');
				$shipping = Mage::getModel('customer/address')
					->setData($orderHub['shipping_address']);

				$this->appendLog('Setting up billing address to the order...');
				$billingAddress = Mage::getModel('sales/order_address')
					->setStoreId($orderHub['store_id'])
					->setAddressType(Mage_Sales_Model_Quote_Address::TYPE_BILLING)
					->setPrefix($billing->getPrefix())
					->setFirstname($orderHub['billing_address']['firstname'])
					->setMiddlename($orderHub['billing_address']['middlename'])
					->setLastname($orderHub['billing_address']['lastname'])
					->setSuffix($billing->getSuffix())
					->setCompany($billing->getCompany())
					->setStreet($billing->getStreet())
					->setCity($billing->getCity())
					->setCountry_id($billing->getCountryId())
					->setRegion($billing->getRegion())
					->setRegion_id($billing->getRegionId())
					->setPostcode($billing->getPostcode())
					->setTelephone($billing->getTelephone())
					->setFax($billing->getFax())
					->setEmail($orderHub['custemail'])
					->setIsDefaultBilling('1')
					->setIsDefaultShipping('0')
					->setSaveInAddressBook('0');

				$order->setBillingAddress($billingAddress);

				$this->appendLog('Setting up shipping address to the order...');
				$shippingAddress = Mage::getModel('sales/order_address')
					->setStoreId($orderHub['store_id'])
					->setAddressType(Mage_Sales_Model_Quote_Address::TYPE_SHIPPING)
					->setPrefix($shipping->getPrefix())
					->setFirstname($orderHub['shipping_address']['firstname'])
					->setMiddlename($orderHub['shipping_address']['middlename'])
					->setLastname($orderHub['shipping_address']['lastname'])
					->setSuffix($shipping->getSuffix())
					->setCompany($shipping->getCompany())
					->setStreet($shipping->getStreet())
					->setCity($shipping->getCity())
					->setCountry_id($shipping->getCountryId())
					->setRegion($shipping->getRegion())
					->setRegion_id($shipping->getRegionId())
					->setPostcode($shipping->getPostcode())
					->setTelephone($shipping->getTelephone())
					->setFax($shipping->getFax())
					->setEmail($orderHub['custemail'])
					->setIsDefaultBilling('0')
					->setIsDefaultShipping('1')
					->setSaveInAddressBook('1');
			}

			$this->appendLog('Setting up billing method to the order...');
			$orderPayment = Mage::getModel('sales/order_payment')
				->setStoreId($orderHub['store_id'])
				->setMethod('hubpayment');

			$order->setPayment($orderPayment);

			$this->appendLog('Setting up shipping method to the order...');
			$order->setShippingAddress($shippingAddress)
				->setShipping_method($orderHub['shippingProvider'] . '_' . $orderHub['shippingService'])
				->setShippingDescription($orderHub['shippingProvider'] . ' - ' . $orderHub['shippingService']);

			$this->appendLog('Adding products to the order...');

			$storeObj = Mage::getModel('core/store')->load($orderHub['store_id']);
			
			
			$subTotal = 0;
			$totalWeight = 0;
			foreach ($orderHub['items'] as $item) 
			{
				$productId = Mage::getModel('catalog/product')->getIdBySku((string)$item['sku']);
				if (!$productId)
				{
					$this->appendLog('Sku ' . $item['sku'] . ' does not exist!');
					return '<error>' . $this->m_LOG . '</error>';
				}
				$this->appendLog('Product was found.');
				$_product = Mage::getModel('catalog/product')->setStore($storeObj)->setStoreId($orderHub['store_id'])->load($productId);
				$this->appendLog('Product loaded from store_id: ' . (string)$orderHub['store_id']);
				
				
				$this->appendLog('Product loaded.');

				$this->appendLog('Product ' . $item['sku'] . ' found, adding to the order...');

				$rowTotal = $item['price'] * $item['qty'];

				$orderItem = Mage::getModel('sales/order_item')
					->setStoreId($orderHub['store_id'])
					->setQuoteItemId(0)
					->setQuoteParentItemId(NULL)
					->setProductId($_product->getId())
					->setProductType($_product->getTypeId())
					->setQtyBackordered(NULL)
					->setTotalQtyOrdered($item['qty'])
					->setQtyOrdered($item['qty'])
					->setName($_product->getName())
					->setSku($_product->getSku())
					->setWeight($_product->getWeight())
					->setPrice($item['price'])
					->setBasePrice($item['price'])
					->setOriginalPrice($_product->getPrice())
					->setRowTotal($rowTotal)
					->setBaseRowTotal($rowTotal);

				$totalWeight += $_product->getWeight();
				$subTotal += $rowTotal;

				$order->addItem($orderItem);
			}

			$total = $subTotal + $orderHub['shippingPrice'];

			$this->appendLog('Calculating Order Totals...');

			$order->setBaseSubtotal($subTotal)
				->setSubtotal($subTotal)
				->setShippingAmount($orderHub['shippingPrice'])
				->setBaseShippingAmount($orderHub['shippingPrice'])
				->setBaseGrandTotal($total)
				->setGrandTotal($total)
				->setWeight($totalWeight);

			if ($orderHub['comment'] != "")
				$order->addStatusHistoryComment($orderHub['comment']);

			$this->appendLog('Saving order...');

			$order->save();

			$this->appendLog('Saved! increment_id: ' . $order->getIncrementId());
			$this->appendLog('Finishing up transaction...');

			$transaction->addObject($order);
			$transaction->addCommitCallback(array($order, 'place'));
			$transaction->addCommitCallback(array($order, 'save'));
			$transaction->save();

			$this->appendLog('Creating invoice...');
			$this->createInvoice($order, $orderHub['status'], $xmlOrder);

			$this->appendLog('Updating custom fields...');
			$this->updateCustomFieldsSourceOrder($order, $orderHub['orderNumber'], $orderHub['sourceStore'], $orderHub['shipping_estimate_days'], $orderHub['sourceSalesChannel'], $orderHub['paymentMethod'], $orderHub['paymentInstallments']);

			$this->appendLog('salesOrderCreate finished successfully');

			return $order->getIncrementId();
		}
		catch(Exception $exception_salesOrderCreate)
		{
			$this->appendLog('salesOrderCreate finished with errors');
			$this->appendLog($this->MakePrettyException($exception_salesOrderCreate));
			return '<error>' . $this->m_LOG . '</error>';
		}
	}
	
	private function prepareOrder($xmlOrder)
	{
		$this->appendLog('prepareOrder started');

		try
		{
			$order = array();

			$orderXMLobj = simplexml_load_string($xmlOrder);

			$orderNumberItem = $orderXMLobj->xpath("//*[name() = 'orderNumber']");
			$order['orderNumber'] = (string)$orderNumberItem[0][0];
			$this->appendLog('sourceOrderNumber: ' . $order['orderNumber']);

			$sourceStoreItem = $orderXMLobj->xpath("//*[name() = 'sourceStore']");
			$order['sourceStore'] = (string)$sourceStoreItem[0][0];

			$shippingEstimateDaysItem = $orderXMLobj->xpath("//*[name() = 'shipping_estimate_days']");
			$order['shipping_estimate_days'] = (string)$shippingEstimateDaysItem[0][0];			
			
			$sourceSalesChannelItem = $orderXMLobj->xpath("//*[name() = 'sourceSalesChannel']");
			$order['sourceSalesChannel'] = (string)$sourceSalesChannelItem[0][0];
			
			$xmlStoreIdItem = $orderXMLobj->xpath("//*[name() = 'store_id']");
			$order['store_id'] = (string)$xmlStoreIdItem[0][0];

			$customerGroupItem = $orderXMLobj->xpath("//*[name() = 'customer_group_id']");
			$order['customer_group_id'] = (string)$customerGroupItem[0][0];

			$customerIsGuest = $orderXMLobj->xpath("//*[name() = 'customer_is_guest']");
			$order['isGuest'] = (string)$customerIsGuest[0][0];
			
			$firstNameItem = $orderXMLobj->xpath("//*[name() = 'customer_firstname']");
			$order['firstname'] = (string)$firstNameItem[0][0];

			$lastnameItem = $orderXMLobj->xpath("//*[name() = 'customer_lastname']");
			$order['lastname'] = (string)$lastnameItem[0][0];

			$midnameItem = $orderXMLobj->xpath("//*[name() = 'customer_middlename']");
			$order['midname'] = (string)$midnameItem[0][0];

			$custemailItem = $orderXMLobj->xpath("//*[name() = 'customer_email']");
			$order['custemail'] = (string)$custemailItem[0][0];

			$custdocnumberItem = $orderXMLobj->xpath("//*[name() = 'customer_docnumber']");
			$order['custdocnumber'] = (string)$custdocnumberItem[0][0];

			$custbdayItem = $orderXMLobj->xpath("//*[name() = 'customer_birthday']");
			$order['custbday'] = (string)$custbdayItem[0][0];

			$order['password'] = trim($order['firstname']).trim($order['lastname'])."*999";

			$products = array();
			$productsXML = $orderXMLobj->xpath("//*[name() = 'product']");

			foreach($productsXML as $rawProductXML)
			{
				$productXMLObj = simplexml_load_string($rawProductXML->asXML());
				$product = array();

				$skuItem = $productXMLObj->xpath("//*[name() = 'sku']");
				$product['sku'] = (string)$skuItem[0][0];

				$qtyItem = $productXMLObj->xpath("//*[name() = 'qty']");
				$product['qty'] = (float)$qtyItem[0][0];

				$priceItem = $productXMLObj->xpath("//*[name() = 'price']");
				$product['price'] = (float)$priceItem[0][0];

				$products[] = $product;
			}

			$order['items'] = $products;

			$this->appendLog('Reading billing Address...');

			$billingstreetItem = $orderXMLobj->xpath("//*[name() = 'billing_address_street']");
			$billingstreet = (string)$billingstreetItem[0][0];
			$billingneighborhoodItem = $orderXMLobj->xpath("//*[name() = 'billing_address_neighborhood']");
			$billingneighborhood = (string)$billingneighborhoodItem[0][0];
			$billingcityItem = $orderXMLobj->xpath("//*[name() = 'billing_address_city']");
			$billingcity = (string)$billingcityItem[0][0];
			$billingpostcodeItem = $orderXMLobj->xpath("//*[name() = 'billing_address_postcode']");
			$billingpostcode = (string)$billingpostcodeItem[0][0];
			$billingtelephoneItem = $orderXMLobj->xpath("//*[name() = 'billing_address_telephone']");
			$billingtelephone = (string)$billingtelephoneItem[0][0];
			$billingmobileItem = $orderXMLobj->xpath("//*[name() = 'billing_address_mobile']");
			$billingmobile = (string)$mobileItem[0][0];
			$billingcountry_idItem = $orderXMLobj->xpath("//*[name() = 'billing_address_country_id']");
			$billingcountry_id = (string)$billingcountry_idItem[0][0];
			$billingregionItem = $orderXMLobj->xpath("//*[name() = 'billing_address_region']");
			$billingregion = (string)$billingregionItem[0][0];
			$billingregionidItem = $orderXMLobj->xpath("//*[name() = 'billing_address_region_id']");
			$billingregionid = (string)$billingregionidItem[0][0];
			$billingaddressnumberItem = $orderXMLobj->xpath("//*[name() = 'billing_address_number']");
			$billingaddressnumber = (string)$billingaddressnumberItem[0][0];
			$billingaddresscomplementItem = $orderXMLobj->xpath("//*[name() = 'billing_address_complement']");
			$billingaddresscomplement = (string)$billingaddresscomplementItem[0][0];

			$order['billing_address'] = array(
				'customer_address_id' => '',
				'prefix' => '',
				'firstname' => $order['firstname'],
				'middlename' => $order['midname'],
				'lastname' => $order['lastname'],
				'suffix' => '',
				'company' =>'', 
				'street' => array(
					'0' => $billingstreet,
					'1' => $billingaddressnumber,
					'2' => $billingaddresscomplement,
					'3' => $billingneighborhood),
				'city' => $billingcity,
				'country_id' => $billingcountry_id,
				'region' => $billingregion,
				'region_id' => $billingregionid,
				'postcode' => $billingpostcode,
				'telephone' => $billingtelephone,
				'fax' => $billingmobile,
				'vat_id' => ''
			);

			$this->appendLog('Reading shipping address and delivery info...');

			$streetItem = $orderXMLobj->xpath("//*[name() = 'shipping_address_street']");
			$street = (string)$streetItem[0][0];
			$cityItem = $orderXMLobj->xpath("//*[name() = 'shipping_address_city']");
			$city = (string)$cityItem[0][0];
			$neighborhoodItem = $orderXMLobj->xpath("//*[name() = 'shipping_address_neighborhood']");
			$neighborhood = (string)$neighborhoodItem[0][0];
			$postcodeItem = $orderXMLobj->xpath("//*[name() = 'shipping_address_postcode']");
			$postcode = (string)$postcodeItem[0][0];
			$telephoneItem = $orderXMLobj->xpath("//*[name() = 'shipping_address_telephone']");
			$telephone = (string)$telephoneItem[0][0];
			$mobileItem = $orderXMLobj->xpath("//*[name() = 'shipping_address_mobile']");
			$mobile = (string)$mobileItem[0][0];
			$country_idItem = $orderXMLobj->xpath("//*[name() = 'shipping_address_country_id']");
			$country_id = (string)$country_idItem[0][0];
			$regionItem = $orderXMLobj->xpath("//*[name() = 'shipping_address_region']");
			$region = (string)$regionItem[0][0];
			$regionidItem = $orderXMLobj->xpath("//*[name() = 'shipping_address_region_id']");
			$regionid = (string)$regionidItem[0][0];
			$addressnumberItem = $orderXMLobj->xpath("//*[name() = 'shipping_address_number']");
			$addressnumber = (string)$addressnumberItem[0][0];
			$addresscomplementItem = $orderXMLobj->xpath("//*[name() = 'shipping_address_complement']");
			$addresscomplement = (string)$addresscomplementItem[0][0];
			$receiverFirstNameItem = $orderXMLobj->xpath("//*[name() = 'shipping_address_receiver_firstname']");
			$receiverFirstName = (string)$receiverFirstNameItem[0][0];
			$receiverLastNameItem = $orderXMLobj->xpath("//*[name() = 'shipping_address_receiver_lastname']");
			$receiverLastName = (string)$receiverLastNameItem[0][0];

			if ($receiverFirstName == "")
				$receiverFirstName = $order['firstname'];

			if ($receiverLastName == "")
				$receiverLastName = $order['lastname'];

			$order['shipping_address'] = array(
				'customer_address_id' => '',
				'prefix' => '',
				'firstname' => $receiverFirstName,
				'middlename' => '',
				'lastname' => $receiverLastName,
				'suffix' => '',
				'company' =>'', 
				'street' => array(
					'0' => $street,
					'1' => $addressnumber,
					'2' => $addresscomplement,
					'3' => $neighborhood),
				'city' => $city,
				'country_id' => $country_id,
				'region' => $region,
				'region_id' => $regionid,
				'postcode' => $postcode,
				'telephone' => $telephone,
				'fax' => $mobile,
				'vat_id' => ''
			);

			$shippingPriceItem = $orderXMLobj->xpath("//*[name() = 'shipping_amount']");
			$order['shippingPrice'] = (float)$shippingPriceItem[0][0];

			$shippingProviderItem = $orderXMLobj->xpath("//*[name() = 'shippingProvider']");
			$order['shippingProvider'] = (string)$shippingProviderItem[0][0];

			$shippingServiceItem = $orderXMLobj->xpath("//*[name() = 'shippingService']");
			$order['shippingService'] = (string)$shippingServiceItem[0][0];

			$paymentMethodItem = $orderXMLobj->xpath("//*[name() = 'paymentMethod']");
			$order['paymentMethod'] = (string)$paymentMethodItem[0][0];			
			
			$paymentInstallmentsItem = $orderXMLobj->xpath("//*[name() = 'paymentInstallments']");
			$order['paymentInstallments'] = (string)$paymentInstallmentsItem[0][0];					
			
			$statusItem = $orderXMLobj->xpath("//*[name() = 'status']");
			$order['status'] = (string)$statusItem[0][0];

			$commentItem = $orderXMLobj->xpath("//*[name() = 'comment']");
			$order['comment'] = $commentItem[0][0];

			$this->appendLog('prepareOrder finished successfully');

			return $order;
		}
		catch(Exception $e)
		{ 
			$this->appendLog('prepareOrder finished with errors: ');
			$this->appendLog($e->getMessage());
			throw new Exception($this->m_LOG);
		}
	}
   
	private function createInvoice($order, $status, $orderXML)
	{
		try
		{
			$this->appendLog('confirm order / createInvoice started');

			if (in_array($status, array('3', '4', '5', '6')))
			{
				$orderXMLobj = simplexml_load_string($orderXML);
				
				$xmlOrderNewStateItem = $orderXMLobj->xpath("//*[name() = 'magentoApprovedState']");
				$xmlOrderNewState = (string)$xmlOrderNewStateItem[0][0];

				$xmlOrderNewStatusItem = $orderXMLobj->xpath("//*[name() = 'magentoApprovedStatus']");
				$xmlOrderNewStatus = (string)$xmlOrderNewStatusItem[0][0];

				if ($xmlOrderNewState == "")
				{
					
					//paid
					if (!$order->canInvoice()) 
					{
						$this->appendLog('order cannot invoice for createOrder');
						return;
					}

					$savedQtys = array();
					$invoice = Mage::getModel('sales/service_order', $order)->prepareInvoice($savedQtys);

					if (!$invoice->getTotalQty()) 
					{
						$this->appendLog('invoice has no totalQty while preparingInvoice');
						return;
					}

					$invoice->setRequestedCaptureCase(Mage_Sales_Model_Order_Invoice::CAPTURE_OFFLINE);
					$invoice->register();

					$invoice->getOrder()->setCustomerNoteNotify(false);
					$invoice->getOrder()->setIsInProcess(true);

					$transactionSave = Mage::getModel('core/resource_transaction')
						->addObject($invoice)
						->addObject($invoice->getOrder());

					$transactionSave->save();
				}
				else
				{
					$order->setStatus($xmlOrderNewStatus);
					$order->setState($xmlOrderNewState);
					$history = $order->addStatusHistoryComment('Confirm. - Hub2b', false);
					$history->setIsCustomerNotified(false);

					$order->save();
				}
			}
		}
		catch(Exception $exCreateInvoice)
		{
			$this->appendLog($this->MakePrettyException($e));
			Mage::logException($exCreateInvoice);
		}
	}
   
	private function updateCustomFieldsSourceOrder($order, $orderNumber, $sourceStore, $shippingEstimateDays, $sourceSalesChannel)
	{
		
		$this->appendLog('updateCustomFieldsSourceOrder started');

		//Create custom fields if it does not exist:
		//sales_flat_order.source_order_number
		//sales_flat_order.source_store
		$this->updateOrderQuoteWithSourceReference();

		try
		{
			$this->appendLog('Updating custom fields: source_order_number and source_store.');

			$order->setsource_order_number($orderNumber);
			$order->setsource_store($sourceStore);
			$order->setshipping_estimate_days($shippingEstimateDays);
			$order->setsource_sales_channel($sourceSalesChannel);
			$order->save();

			$this->appendLog('Order ' . $increment_id . ' had its customfields successfully updated!');
		}
		catch(Exception $srcRefException)
		{ 
			Mage::logException($srcRefException);
		}
	}
   
	public function orderInfo($id)
	{
		if (!$this->isAPI())
		{
			$this->appendLog('orderInfo only available through API');
			return "<error>not API</error>";
		}	

		$out = "";

		try
		{
			$order = Mage::getModel('sales/order')->loadByIncrementId($id);

			if ($order->getIncrementId() == null || strlen($order->getIncrementId()) == 0)
				return "<error>incrementId not found.</error>";

			$out.= "<order>\n";

			$out.= "<orderHeader>\n";
			$out.= "<state>".$order->getState()."</state>";
			$out.= "<status>".$order->getStatus()."</status>";
			$out.= "<orderNumber>".$order->getIncrementId()."</orderNumber>\n";
			$out.= "<date>".$order->getCreatedAt()."</date>\n";
			$out.= "<store>".$order->getStoreId()."</store>\n";
			$out.= "<totalamount>".$order->getGrandTotal()."</totalamount>\n";

			$out.= "<address>\n";

			$xml_billing = new SimpleXMLElement('<data></data>');
			$this->array_to_xml($order->getBillingAddress()->getData(), $xml_billing);
			$dom = dom_import_simplexml($xml_billing);
			$xml_billing_data = $dom->ownerDocument->saveXML($dom->ownerDocument->documentElement);
			$out.= $xml_billing_data;

			$out.= "</address> \n";

			$out.="<shipToAddress>\n";

			$xml_shipping = new SimpleXMLElement('<data></data>');
			$this->array_to_xml($order->getShippingAddress()->getData(), $xml_shipping);
			$dom = dom_import_simplexml($xml_shipping);
			$xml_shipping_data = $dom->ownerDocument->saveXML($dom->ownerDocument->documentElement);
			$out.= $xml_shipping_data;

			$out.= "</shipToAddress>\n";

			$out.= "</orderHeader>\n";
			$out.= "<orderDetail> \n";
			foreach ($order->getAllItems() as $itemId => $item)
			{
				// textova polozka
				$out.= "<orderItem> \n";
				$itemname =  $item->getName();
				$itemname =  str_replace('&', " ", $itemname);
				$out.= "<sku>{$item->getSku()}</sku>\n";
				$out.= "<name>{$itemname}</name> \n";
				$out.= "<quantity>{$item->getQtyOrdered()}</quantity>\n";
				$out.= "<unitPrice>{$item->getPrice()}</unitPrice>\n";
				$out.= "</orderItem>\n";
			}
			$out.= "</orderDetail>\n";

			$xml_fullOrder = new SimpleXMLElement('<data></data>');	

			$this->array_to_xml($order->getData(), $xml_fullOrder);
			$dom = dom_import_simplexml($xml_fullOrder);
			$xml_fullOrder_data = $dom->ownerDocument->saveXML($dom->ownerDocument->documentElement);
			$out .= "<fullOrder>" .  $xml_fullOrder_data . "</fullOrder>";

			//we create the native invoice during orderCreate or orderConfirm (update)
			if ($order->hasInvoices()) 
			{
				$invIncrementIDs = array();
				foreach ($order->getInvoiceCollection() as $inv) 
				{
					$xml_invoice = new SimpleXMLElement('<data></data>');

					$this->array_to_xml($inv->getData(), $xml_invoice);

					$dom = dom_import_simplexml($xml_invoice);
					$xml_invoice_data = $dom->ownerDocument->saveXML($dom->ownerDocument->documentElement);

					$comments = $order->getStatusHistoryCollection(true);

					$commentContent = "";
					foreach ($comments as $c) 
						$commentContent.=$c->getData('comment')."\n";

					//nf_series, nf_number, nf_key, nf_issuedate
					$nf_data = explode("\n", $commentContent);
					$nf_result = $this->getNFInfoFromComments($nf_data);
					if ($nf_result == "")
					{
						$nf_data = explode(";", $commentContent);
						$nf_result = $this->getNFInfoFromComments($nf_data);

						if ($nf_result == "")
						{
							$nf_data = explode("\r", $commentContent);
							$nf_result = $this->getNFInfoFromComments($nf_data);

							if ($nf_result == "")
							{
								//for those who integrate Bling with Magento for invoices.
								$nf_data = $commentContent;
								$nf_result = $this->getNFInfoFromCommentsBlingFormat($nf_data);

								if ($nf_result == "")
								{
									//for those who integrate Tecmicro with Magento for invoices.
									$nf_data = $commentContent;
									$nf_result = $this->getNFInfoFromCommentsTecmicro($nf_data);								
								}
							}
							
							if ($nf_result == "")
								$nf_result = $this->getNFInfoFromTable($id);
						}
					}
					
					$out.= "<invoice>" . $xml_invoice_data . $nf_result . "</invoice>";
				}
			}

			if ($order->hasShipments()) 
			{
				foreach($order->getShipmentsCollection() as $shipment)
				{
					$xml_shipment = new SimpleXMLElement('<data></data>');

					$this->array_to_xml($shipment->getData(), $xml_shipment);

					$dom = dom_import_simplexml($xml_shipment);
					$xml_shipping_data = $dom->ownerDocument->saveXML($dom->ownerDocument->documentElement);

					$trackings = "";

					$shipmentIncrementId = $shipment->getIncrementId();
					$shipmentData = Mage::getModel('sales/order_shipment')->loadByIncrementId($shipmentIncrementId);
					foreach ($shipmentData->getCommentsCollection()->getItems() as $shipmentComment)
					{						
						$shipmentCommentData .=  $shipmentComment->getData('comment') . "\n";
					} 

					$tracking_data = "";
					$tracking_result = "";

					$breakLines = array("\n", ";", "\r");
					for ($i=0; $i < count($breakLines); $i++)
					{
						$tracking_data = explode($breakLines[$i], $shipmentCommentData);
						$tracking_result = $this->getTrackingInfoFromComments($tracking_data);
						if($tracking_result != "")
							break;
					}

					foreach($shipment->getAllTracks() as $tracknum)
					{
						//$trackings .= $tracknum->getNumber()." - NF: ".$tracknum->getTitle()." - Data: ".$tracknum->getDateCreation();
						$xml_track = new SimpleXMLElement('<data></data>');
						$this->array_to_xml($tracknum->getData(), $xml_track);
						$dom = dom_import_simplexml($xml_track);
						$xml_track_data = $dom->ownerDocument->saveXML($dom->ownerDocument->documentElement);
						$trackings .= $xml_track_data;
					}

					$xml_shipping_data .= "<trackings>". $trackings . $tracking_result ."<comments>".$shipmentCommentData."</comments></trackings>";

					$out.= "<shipment>".$xml_shipping_data."</shipment>";
				}
			}

			$out.= "</order>";

			$out = str_replace("&","&amp;",$out);

			$xml_data = new SimpleXMLElement($out);

			//saving generated xml file; 
			return $xml_data->asXML();
		}
		catch (Exception $e)
		{
			Mage::logException($e);
			$this->appendLog($this->MakePrettyException($e));
			$this->appendLog($out);
			return '<error>' . '<![CDATA[' . $this->m_LOG . ']]>' . '</error>';
		}
	}

	private function getTrackingInfoFromComments($tracking_data)
	{
		$xml_tracking_data = "";
		$foundTrackingUrl = false;

		foreach ($tracking_data as $tracking_line)
		{
			$tracking_line = strip_tags($tracking_line);

			if (strpos(strtoupper($tracking_line), 'URLRASTREIO:') !== false) {
				$xml_tracking_data = "<tracking_url>" . trim(substr($tracking_line, strpos(strtoupper($tracking_line), 'URLRASTREIO:')+12)) . "</tracking_url>";
				$foundTrackingUrl = true;
			}
		}

		return $foundTrackingUrl ? $xml_tracking_data : "";
	}

	private function getNFInfoFromComments($nf_data)
	{
		$foundKey = false;
		$foundNumber = false;
		$foundSeries = false;
		$xml_invoice_data = "";
		
		foreach ($nf_data as $nf_line)
		{
			$nf_line = strip_tags($nf_line);

			if (strpos(strtoupper($nf_line), 'CHAVE:') !== false) {
				$xml_invoice_data.= "<nf_key>".trim(substr($nf_line, strpos(strtoupper($nf_line), 'CHAVE:')+6))."</nf_key>";
				$foundKey = true;
			}
			else if (strpos(strtoupper($nf_line), 'SERIE:') !== false) {
				$xml_invoice_data.= "<nf_series>".trim(substr($nf_line, strpos(strtoupper($nf_line), 'SERIE:')+6))."</nf_series>";
				$foundSeries = true;
			}
			else if (strpos(strtoupper($nf_line), 'NUMERO:') !== false) {
				$xml_invoice_data.= "<nf_number>".trim(substr($nf_line, strpos(strtoupper($nf_line), 'NUMERO:')+7))."</nf_number>";
				$foundNumber = true;
			}
		}

		return $foundKey && $foundNumber && $foundSeries ? $xml_invoice_data : "";
	}

	private function getNFInfoFromCommentsBlingFormat($nf_data)
	{
		$foundKey = false;
		$foundNumber = false;
		$foundSeries = false;
		$xml_invoice_data = "";
		
		$nf_line = $nf_data;

        $search = 'Nota fiscal:</b>';
		if (strpos($nf_line, $search) !== false) {
		    $inipos = strpos($nf_line, $search)+strlen($search);
		    $finalpos = strpos($nf_line, '<', $inipos);
			$xml_invoice_data.= "<nf_number>".trim(substr($nf_line, $inipos, $finalpos-$inipos))."</nf_number>";
			$foundNumber = true;
		}
		
		$search = 'Série: </b>';
		if (strpos($nf_line, $search) !== false) {
		    $inipos = strpos($nf_line, $search)+strlen($search);
		    $finalpos = strpos($nf_line, '<', $inipos);

			$xml_invoice_data.= "<nf_series>".trim(substr($nf_line, $inipos, $finalpos-$inipos))."</nf_series>";
			$foundSeries = true;
		}
		
		$search = 'Chave de Acesso: </b>';
		if (strpos($nf_line, $search) !== false) {
		    $inipos = strpos($nf_line, $search)+strlen($search);
		    $finalpos = strpos($nf_line, '<', $inipos);
		    
			$xml_invoice_data.= "<nf_key>".trim(substr($nf_line, $inipos, $finalpos-$inipos))."</nf_key>";
			$foundKey = true;
		}

		return $foundKey && $foundNumber && $foundSeries ? $xml_invoice_data : "";
	}
	
	private function getNFInfoFromCommentsTecmicro($nf_data)
	{
		$nf_line = str_replace(" ", "", $nf_data);

        $search = 'Chavedeacesso:';
		if (strpos($nf_line, $search) !== false) {
		    $inipos = strpos($nf_line, $search)+strlen($search);
		    $finalpos = $inipos + 44;
			
			$key = trim(substr($nf_line, $inipos, $finalpos-$inipos));
			$number = trim(substr($key, 22, 3));
			$serie = trim(substr($key, 25, 9));

			return "<nf_key>" . $key . "</nf_key>" . 
				"<nf_series>" . $serie . "</nf_series>" . 
				"<nf_number>" . $number . "</nf_number>";
		}
		
		return "";
	}
	
	private function getNFInfoFromTable($increment_id)
	{
		try
		{
			$resource = Mage::getSingleton('core/resource');
			$readConnection = $resource->getConnection('core_read');
			$query = "select * from order_invoice_hub2b where increment_id = " . $increment_id . " limit 1;";

			$row = $readConnection->fetchAll($query);
			$isValidReturn = !is_null($row) && isset($row[0]['nf_key'], $row[0]['nf_series'], $row[0]['nf_number']);
			
			return $isValidReturn ? 
				"<nf_key>" . $row[0]['nf_key'] . "</nf_key>" . 
				"<nf_series>" . $row[0]['nf_series'] . "</nf_series>" . 
				"<nf_number>" . $row[0]['nf_number'] . "</nf_number>" : "";
		}
		catch (Exception $e)
		{
			return "";
		}
	}

	public function orderListByStatus($state)
	{
		try
		{
			$now = Mage::getModel('core/date')->timestamp(time());
			$fromDate = date('Y-m-d' . ' 00:00:00', strtotime('-2 week'));
			$toDate = date('Y-m-d' . ' 23:59:59', $now);

			$orders = Mage::getModel('sales/order')->getCollection()
				->addFieldToFilter('state', $state)
				->addFieldToFilter('created_at', array('from' => $fromDate, 'to' => $toDate));

			$response = "<root>";
			foreach ($orders as $order)
			{
				$xml_order = new SimpleXMLElement($this->orderInfo($order->getRealOrderId()));
				$dom = dom_import_simplexml($xml_order);
				$xml_order_data = $dom->ownerDocument->saveXML($dom->ownerDocument->documentElement);
				$response.= $xml_order_data;
			}
			$response .= "</root>";

			$xml_order = new SimpleXMLElement($response);

			return $xml_order->asXML();
		}
		catch (Exception $e)
		{
			Mage::logException($e);
			$this->appendLog($this->MakePrettyException($e));
			return '<error>'.$this->m_LOG.'</error>';
		}
	}

	public function createUpdateProduct($data)
	{
		if (!$this->isAPI())
		{
			$this->appendLog('createUpdateProduct only available through API');
			return "<error>not API</error>";
		}	

		try
		{
			$productObjXMLobj = simplexml_load_string($data);

			$xmlStoreIdItem = $productObjXMLobj->xpath("//*[name() = 'store_id']");
			$xmlStoreId = (string)$xmlStoreIdItem[0][0];
			if ($xmlStoreId != '')
				Mage::app()->setCurrentStore($xmlStoreId);
			else
				Mage::app()->setCurrentStore(Mage_Core_Model_App::ADMIN_STORE_ID);

			$productObj = Mage::getModel('catalog/product');

			$skuItem = $productObjXMLobj->xpath("//*[name() = 'sku']");
			$sku = (string)$skuItem[0][0];
			$nameItem = $productObjXMLobj->xpath("//*[name() = 'name']");
			$name = (string)$nameItem[0][0];
			$weightItem = $productObjXMLobj->xpath("//*[name() = 'weight']");
			$weight = (string)$weightItem[0][0];
			$priceItem = $productObjXMLobj->xpath("//*[name() = 'price']");
			$price = (string)$priceItem[0][0];
			$specialpriceItem = $productObjXMLobj->xpath("//*[name() = 'specialprice']");
			$specialprice = (string)$specialpriceItem[0][0];
			$stockItem = $productObjXMLobj->xpath("//*[name() = 'stock']");
			$stock = (string)$stockItem[0][0];
			$descriptionItem = $productObjXMLobj->xpath("//*[name() = 'description']");
			$description = (string)$descriptionItem[0][0];
			$shortdescriptionItem = $productObjXMLobj->xpath("//*[name() = 'short_description']");
			$shortdescription = (string)$shortdescriptionItem[0][0];

			$productData=array(
				'name' => $name,
				'sku' => $sku,
				'description' => $description,
				'short_description' => $shortdescription,
				'weight' => $weight, // whatever your product weighs
				'status' => 1, // 1 => enabled, 0 => disabled
				'visibility' => '4', // 1 => Not Visible Individually, 2 => Catalog, 3 => Search, 4 => Catalog, Search
				'attribute_set_id' => 4, // default
				'type_id' => 'simple',
				'price' => $price,
				'special_price' => $specialprice, // optional
				'tax_class_id' => 0, // None
				'page_layout' => 'one_column',
			);
			// traversing through each index of productData
			foreach($productData as $key => $value)
				$productObj->setData($key,$value);

			$productObj->setWebsiteIds(array(1));
			$productObj->save();

			return $productObj->getId();
		}
		catch (Exception $e)
		{
			Mage::logException($e);
			$this->appendLog($this->MakePrettyException($e));
			return '<error>'.$this->m_LOG.'</error>';
		}
	}
}
?>
