<?php

class Hub2b_Hubshipping_Model_Carrier
    extends Mage_Shipping_Model_Carrier_Abstract
    implements Mage_Shipping_Model_Carrier_Interface
{
   protected $_code = 'hubshipping';

	public function getAllowedMethods()
	{   
      $shippingMethod = Mage::registry('customShippingInfo' . Mage::getSingleton('api/session')->getSessionId());
      
      if ($this->isAPI() && $shippingMethod['service'] != 0)
         return array($shippingMethod['service'] => $shippingMethod['service']);
      
      return array(); //none allowed
	}
	
	protected function isAPI()
	{
		return Mage::getSingleton('api/session')->getSessionId() != "";
	}
	
	public function collectRates(Mage_Shipping_Model_Rate_Request $request)
   {
      if (!$this->getConfigFlag('active')) {
         Mage::log('HubCarrier not Active');
         return false;
      }

      if (!$this->isAPI()) {
         Mage::log('HubCarrier not available for not API');
			return false;
		}

      $sessionId = Mage::getSingleton('api/session')->getSessionId();
      $customShipping = Mage::registry('customShippingInfo' . $sessionId);
            
		$method = Mage::getModel('shipping/rate_result_method'); //new instance
      
      //Setting Carrier/Provider
      $method->setCarrier($customShipping['provider']);
      $method->setCarrierTitle($customShipping['provider']);
      
      //Setting Method/Service
      $method->setMethod($customShipping['service']);
      $method->setMethodTitle($customShipping['service']);
      
      //Setting Price
      if (isset($customShipping['price'])) {
         $method->setCost($customShipping['price']);
         $method->setPrice($customShipping['price']);
      }
      
      $result = Mage::getModel('shipping/rate_result');
		$result->append($method);
		
		return $result;
	}
}
?>
